/*  ===========================================================================
 *   Copyright (c) Texas Instruments Inc 2006
 *
 *   Use of this software is controlled by the terms and conditions found in
 *   the license agreement under which this software has been supplied.
 *   ==========================================================================
 */


/** ===========================================================================
 * TCP2_Channel_Density.h
 * @desc  header file for TCP2 channel density test.
 * ============================================================================
 */
/* ============================================================================
 *  Revision History
 *  ===============
 *  11-July-2006   Brighton     File Created.
 * ============================================================================
 */
 
 
#ifndef _TCP2_CHANNEL_DENSITY_H_
#define _TCP2_CHANNEL_DENSITY_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <csl_tcp2.h>

#define MAX_TCP2_FRAME_LEN 	20730
#define MAX_TCP2_TAIL_LEN 	30
//The length of data for scale factor estimation is (1<<TCP2_SCALE_EST_LEN_BITS) 
//TCP2_SCALE_EST_LEN_BITS must no more than 16 to avoid overflow
#define TCP2_SCALE_EST_LEN_BITS 	11
/* TCP number of extrinsic factors */
#define NUM_EXTRINSIC_FACTORS 	16

void TCP2_Channel_Density_Test();
int TestTCP2(TCP2_BaseParams *tcpParameters, Uint8 uiSigma);
void TCP2_deintUnpunctSoft3(Int8 *restrict UserData, Uint32 *restrict UserDataRate5,
                           Uint16 *restrict hTcpInterleaverTable, const Uint32 length);
void TCP2_ScaleData(Int8 * restrict InData, Int16 * restrict OutData, Uint32  Length);
void TCP2_ScaleData_Theory(Int8 * restrict InData, Int16 * restrict OutData, Uint32  Length, Uint32 uiSigma);
void TCP2_deintUnpunctData(Int16   *restrict	PunctData,	//rate 1/3 data 2nd 
 	                       Uint32 *restrict	UnPunctData,	//rate 1/5 data 
 	                       Uint16 *restrict DeintTable,	//deintTable
                           TCP2_BaseParams *tcpParameters);

Uint32 TCP2_genParams_bf (
    TCP2_BaseParams  *restrict configBase,
    TCP2_Params      *restrict configParams) ;
void  TCP2_calcSubBlocks_bf (
	TCP2_Params *configParms );
#ifdef __cplusplus
}
#endif

#endif /*_TCP2_CHANNEL_DENSITY_H_*/
