/*  ===========================================================================
 *   Copyright (c) Texas Instruments Inc 2006
 *
 * GENERAL DISCLAIMER                                                       *
 * ------------------                                                       *
 * All software and related documentation is provided "AS IS" and without   *
 * warranty or support of any kind and Texas Instruments expressly disclaims*
 * all other warranties, express or implied, including, but not limited to, *
 * the implied warranties of merchantability and fitness for a particular   *
 * purpose.  Under no circumstances shall Texas Instruments be liable for   *
 * any incidental, special or consequential damages that result from the    *
 * use or inability to use the software or related documentation, even if   *
 * Texas Instruments has been advised of the liability.                     *
 ****************************************************************************
 *   ==========================================================================
 */


/** ===========================================================================
 * @desc VCP2/TCP2 channel density test.
 *
 * ============================================================================
 */
/* ============================================================================
 *  Revision History
 *  ===============
 *  11-July-2006   Brighton     File Created.
 * ============================================================================
 */

#include <csl_tsc.h>
#include <csl_cache.h>
#include "val_util.h"
#include "tcp2_edma.h"

#include "stdio.h"
#include "main_VCP2_TCP2_Channel_Density.h"
//#include "VCP2_Channel_Density.h"
#include "TCP2_Channel_Density.h"
#include "VCP2_TCP2_EDMA.h"

main()
{
    Uint16 * mem_ptr;
    int instNum = 0;

	CSL_tscEnable(); 	//Enable time stamp counter for profiling
	CACHE_setL1pSize(CACHE_L1_32KCACHE);
	CACHE_setL1dSize(CACHE_L1_32KCACHE);
	CACHE_setL2Size(CACHE_0KCACHE);

    /* Enable the TCP2/VCP in power sleep controller */
	
    for (mem_ptr = (Uint16*)(0x02A0080C);  mem_ptr < (Uint16*)(0x02A0082C); mem_ptr++) *(mem_ptr) = 0xFFF0;

   /* Initialization of CSL module */
    TCP2_init(instNum);

  /* Enabling TCP2 Clock by Programming the Power Saver */
    enableTCP();

    /* Enable VCP module in PowerSaver */
    enableVCP2();

 /* Initialization of EDMA */
 
    edma3ModuleInit(CSL_EDMA3_REGION_1);
	Init_VCP2_TCP2_EDMA();


//	puts("VCP2_Channel_Density_Test...");
//	VCP2_Channel_Density_Test();

	puts("TCP2_Channel_Density_Test...");
	TCP2_Channel_Density_Test();
}

 

