// Various functions to enable specific module in Curie PSC
#include "val_util.h"
#include "psc_util.h"
//#define DEFAULT_PSC_SETUP
/*
#define PSC_BASE    0x02AC0000

#define PSC_PTCMD   PSC_BASE + 0x120
#define PSC_PTSTAT  PSC_BASE + 0x128

#define PSC_PDCTL0  PSC_BASE + 0x300
#define PSC_PDCTL1  PSC_BASE + 0x304
#define PSC_PDCTL2  PSC_BASE + 0x308
#define PSC_PDCTL3  PSC_BASE + 0x30C
#define PSC_PDCTL4  PSC_BASE + 0x310
#define PSC_PDCTL5  PSC_BASE + 0x314

#define PSC_MDCTL0  PSC_BASE + 0xA00
#define PSC_MDCTL1  PSC_BASE + 0xA04
#define PSC_MDCTL2  PSC_BASE + 0xA08
#define PSC_MDCTL3  PSC_BASE + 0xA0C
#define PSC_MDCTL4  PSC_BASE + 0xA10
#define PSC_MDCTL5  PSC_BASE + 0xA14
#define PSC_MDCTL6  PSC_BASE + 0xA18
#define PSC_MDCTL7  PSC_BASE + 0xA1C
#define PSC_MDCTL8  PSC_BASE + 0xA20
#define PSC_MDCTL9  PSC_BASE + 0xA24
#define PSC_MDCTL10 PSC_BASE + 0xA28
#define PSC_MDCTL11 PSC_BASE + 0xA2C
*/
// Read the specified memory location
Uint32 readperiph (Uint32 Addr)
{
  Uint32 *Loc;
  Loc = (Uint32 *) Addr;
  return (*Loc);
}

// Write the specified memory location with the specified Data
void writeperiph (Uint32 Addr, Uint32 Data)
{
  Uint32 *Loc;
  Loc  = (Uint32 *) Addr;
  *Loc = Data;
}

#ifdef DEFAULT_PSC_SETUP
// This function is used to Enable SRIO in PSC control module.
void enableSRIO(void)

{

}

// This function is used to Enable TCP2_0 in PSC control module.
void enableTCP(void)

{

}

// This function is used to Enable TCP2_1 in PSC control module.
void enableTCP_1(void)

{

}


// This function is used to Enable VCP2 in PSC control module.
void enableVCP2(void)

{

}

// This function is used to Enable RSA0 in PSC control module.
void enableRSA0(void)

{

}

// This function is used to Enable RSA1 in PSC control module.
void enableRSA1(void)

{

}


// This function is used to Enable EMIF64 in PSC control module.
void enableEMIF64(void)

{

}


// This function is used to Enable HPI in PSC control module.
void enableHPI(void)

{

}


// This function is used to Enable UTOPIA in PSC control module.
void enableUTOPIA(void)
{

}


#else
// This function is used to Enable SRIO in PSC control module.
void enableSRIO(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL1);  // Power Domain A 
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL1, data);

        data = readperiph(PSC_MDCTL7); // Module Domain 7
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL7, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000002;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000002 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}

// This function is used to Enable TCP2_0 in PSC control module.
void enableTCP(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL2); //Power Domain B
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL2, data);

        data = readperiph(PSC_MDCTL8); // Module Domain 8
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL8, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000004;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000004 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}

// This function is used to Enable TCP2_1 in PSC control module.
void enableTCP_1(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL3);  // Power Domain  C
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL3, data);

        data = readperiph(PSC_MDCTL9); // Module Domain 9
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL9, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000008;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000008 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}


// This function is used to Enable VCP2 in PSC control module.
void enableVCP2(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL4); // Power Domain  D
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL4, data);

        data = readperiph(PSC_MDCTL10); // Module Domain 10
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL10, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000010;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000010 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}

// This function is used to Enable RSA0 in PSC control module.
void enableRSA0(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL0);  // Power Domain 0
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL0, data);

        data = readperiph(PSC_MDCTL0);  // Module Domain 0
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL0, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000001;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000001 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}

// This function is used to Enable RSA1 in PSC control module.
void enableRSA1(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL0); // Power Domain 0
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL0, data);

        data = readperiph(PSC_MDCTL1); // Module Domain 1
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL1, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000001;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000001 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}


// This function is used to Enable EMIF64 in PSC control module.
void enableEMIF64(void)

{
        Uint32 data, temp;

        data = readperiph(PSC_PDCTL0); // Power Domain 0
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL0, data);

        data = readperiph(PSC_MDCTL2); // Module Domain 2
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL2, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000001;
        writeperiph(PSC_PTCMD, data);
		data = 0;
        /* wait till ptstat.go goes to zero */
        do { 
        temp = readperiph(PSC_PTSTAT);
        data = 0x00000001 & temp; 
        } while (data != 0x0);
		asm("	NOP 5");
}


// This function is used to Enable HPI in PSC control module.
void enableHPI(void)

{
        Uint32 data, temp;

        data = readperiph(PSC_PDCTL0); // Power Domain 0
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL0, data);

        data = readperiph(PSC_MDCTL3); // Module Domain 3
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL3, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000001;
        writeperiph(PSC_PTCMD, data);

        data = 0;
        /* wait till ptstat.go goes to zero */
        do { 
        temp = readperiph(PSC_PTSTAT);
        data = 0x00000001 & temp; 
        } while (data != 0x0);
		asm("	NOP 5");

}


// This function is used to Enable UTOPIA in PSC control module.
void enableUTOPIA(void)

{
        Uint32 data;

        data = readperiph(PSC_PDCTL0); // Power Domain 0
        data = data | 0x00000001;
        writeperiph(PSC_PDCTL0, data);

        data = readperiph(PSC_MDCTL4); // Module Domain 4
        data = data | 0x00000003;
        writeperiph(PSC_MDCTL4, data);

        data = readperiph(PSC_PTCMD);
        data = data | 0x00000001;
        writeperiph(PSC_PTCMD, data);

        /* wait till ptstat.go goes to zero */
        do { data = 0x00000001 & readperiph(PSC_PTSTAT); } while (data != 0x0);

}
#endif









