/*****************************************************************************\
*           TEXAS INSTRUMENTS INCORPORATED PROPRIETARY INFORMATION           
*                                                                            
*  Property of Texas Instruments 
*  For  Unrestricted  Internal  Use  Only 
*  Unauthorized reproduction and/or distribution is strictly prohibited.  
*  This product is protected under copyright law and trade secret law 
*  as an unpublished work.  
*  Created 2004, (C) Copyright 2003 Texas Instruments.  All rights reserved.
*------------------------------------------------------------------------------
*  Filename       : tcp2_edma.h
*  Date Created   : Oct 18, 2004
*  Last Modified  : Jun 16, 2005
*  Description    : Constants definition for TCP2 and EDMA
*  History        :
*  Project        : Himalaya
*  Author         : Manohar
\*****************************************************************************/

#ifndef _TCP2_EDMA_H_
#define _TCP2_EDMA_H_

#include "csl_edma3.h"	// changed csl_edma.h to csl_edma3.h by Thara
#include "csl_intc.h"
#include <csl_tcp2Aux.h>

#define TCP_STATE_5                 5    
#define TCP_STATE_9                 9    
#define TCP_OUT_PARAM_WORD_COUNT    3
#define TCP_SA_MODE                 0x00
#define TCP_SP_FIRST_SUBFRAME       0x01    
#define TCP_SP_MIDDLE_SUBFRAME      0x02
#define TCP_SP_LAST_SUBFRAME        0x03
#define TCP_INPUT_CONF_REG_COUNT    16

#define TCP_START                           1
#define TCP_DEBUG_MODE_INIT                 4
#define TCP_DEBUG_MODE_EXECUTE_ONE_MAP      5
#define TCP_DEBUG_MODE_COMPLETE_DECODE      6
#define TCP_SOFT_RESET                      7


#define TCP_ENDIAN_WORD		  0x00000300
#define TCP_BIG_ENDIAN_WORD	  0x00000303
#define TCP_EMULATION_WORD	  0x00000003
#define BIG_ENDIAN		  0
#define LITTLE_ENDIAN		  1
#define NATIVE_FORMAT		  1

#define HIMALAYA_TEST_GEM_DRAELO  0xffffffff
#define HIMALAYA_TEST_GEM_DRAEHI  0xffffffff
#define CSL_EDMA3_TCP_XEVT	  31
#define CSL_EDMA3_TCP_REVT	  30

#define CSL_XMT_TCC		  1
#define CSL_RCV_TCC		  4
#define CSL_RCV_TCC_DUMMY	  6

#define TCP_RCV_CHANNEL_NUM	  4

#define  PSVR_BASE                 0x02AC0000 
#define  PSVR_LCKREG               PSVR_BASE + 0x4
#define  PSVR_MDCTL0               PSVR_BASE + 0x8
#define  PSVR_MDSTAT0              PSVR_BASE + 0x14
#define  PSVR_TCP_EN               0x5
#define  PSVR_TCP_LCKVAL           0x0F0A0B00
#define  PSVR_TCP_MDSTAT_MASK      0x7
#define  PSVR_TCP_MDSTAT_EN        0x1

#define  MAX_ACNT_IN_WI_BACKWARD_COMPATIBILITY_MODE  0x3FFF

/* Param Entry Number */

#define PARAM_ENTRY_NUM_IC        0
#define PARAM_ENTRY_NUM_SP        1
#define PARAM_ENTRY_NUM_IL        2

#define PARAM_ENTRY_NUM_HD        3
#define PARAM_ENTRY_NUM_OP        4

#define PARAM_ENTRY_NUM_DM        5

#define TCP_IC_CONF_SIZE	  64	/* no of bytes */
#define TCP_OP_CONF_SIZE	  12	/* no of bytes */
#define NO_OF_OUT_REGS		   3    

#define TCP_CFG_BASE_ADDRESS   	  0x02BA0000

/* Chip Level Addresses for TCP registers in CFG Space */

#define TCP_PERIPHERAL_ID_REG_ADDRESS 	  	  TCP_CFG_BASE_ADDRESS + 0x00
#define TCP_EXECUTION_REG_ADDRESS	  	  TCP_CFG_BASE_ADDRESS + 0x4C
#define TCP_ENDIAN_MODE_REG_ADDRESS	  	  TCP_CFG_BASE_ADDRESS + 0x50
#define	TCP_ERROR_REG_ADDRESS		  	  TCP_CFG_BASE_ADDRESS + 0x60
#define TCP_STATUS_REG_ADDRESS		  	  TCP_CFG_BASE_ADDRESS + 0x68
#define	TCP_EMULATION_CONTROL_REG_ADDRESS 	  TCP_CFG_BASE_ADDRESS + 0x70

#define  TCP_ICMEM_ADDR           	0x50000000u
#define  TCP_SPMEM_ADDR     	  	0x50010000u
#define  TCP_EXTRNSICMEM_W0_ADDR   	0x50030000u 
#define  TCP_EXTRNSICMEM_W1_ADDR   	0x50040000u 
#define  TCP_ILMEM_ADDR			0x50050000u 
#define  TCP_HDMEM_ADDR 	   	0x50060000u 
#define  TCP_OPMEM_ADDR			0x50000040u

void edmaModuleInit(Uint32 edma_region_num);
void edmaCloseHandles();
void edmaParamSetup (CSL_Edma3ParamHandle hParam, Uint32 option, //changed CSL_EdmaParamHandle to CSL_Edma3ParamHandle by Thara
                     Uint32 *srcAddr, Uint32 *dstAddr, Uint32 Acnt,
                     Uint32 Bcnt, Uint32 Ccnt, Uint32 Bidx,Uint32 Cidx,CSL_Edma3ParamHandle);
extern void edmaModuleInit(Uint32 edma_region_num);
extern void edmaCloseHandles();
//extern CSL_EdmaRegionHandle   shHandle;	//changed CSL_EdmaRegionHandle to CSL_Edma3RegionHandle by Thara					
extern CSL_Edma3Handle hModule;

#endif

