/****************************************************************************\
 *           Copyright (C) 2000 Texas Instruments Incorporated.             *
 *                           All Rights Reserved                            *
 *                                                                          *
 * GENERAL DISCLAIMER                                                       *
 * ------------------                                                       *
 * All software and related documentation is provided "AS IS" and without   *
 * warranty or support of any kind and Texas Instruments expressly disclaims*
 * all other warranties, express or implied, including, but not limited to, *
 * the implied warranties of merchantability and fitness for a particular   *
 * purpose.  Under no circumstances shall Texas Instruments be liable for   *
 * any incidental, special or consequential damages that result from the    *
 * use or inability to use the software or related documentation, even if   *
 * Texas Instruments has been advised of the liability.                     *
 ****************************************************************************
 *                                                                          *
 * Written by :                                                             *
 *            Sebastien Tomas  (VCP2/TCP2)                                  *
 *            Texas Instruments                                             * 
 *            12 May, 2005                                                  *
 *                                                                          *
 * The purpose of this test is to evaluate Bit-Error Rate performance for   *
 * both VCP2 and TCP2 co-processors in the TCI6482 (Himalaya)               *
 *									                                        *
 * This test should not be redistributed for any reason without             *
 * permission.                                                              *
 *                                                                          *
 Modified by Brighton Feng 12 July, 2006 for VCP2/TCP2 channel density test.
\***************************************************************************/

#ifndef __TURBOENCODE_H
#define __TURBOENCODE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <tistdtypes.h>

Int32 TurboEncode3GPP(const Uint32 *in, Uint32 *out, Uint16 *table, const Uint32 size, Uint32 rate);
Int32 TurboEncode3GPP2(const Uint32 *in, Uint32 *out, Uint16 *table, const Uint32 size, Uint32 rate);
Uint32 TurboInterleaveBits(const Uint32 *input, Uint32 *output, const Uint32 dataLen, const Uint16 *iltable);
Uint32 TurboInterleaverTableGenerator3GPP(Uint16 *T, Uint32 K);
Uint32 TurboInterleaverTableGenerator3GPP2(Uint16 *T, Uint32 K);
int lrsc(const unsigned int *in, unsigned char *out, const unsigned int size, const unsigned short *feedForward, const unsigned short feedback);


#ifdef __cplusplus
}
#endif

#endif
